"use strict";

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PER_PAGE_NUM = exports.BEGIN = exports.CURRENT_PAGE = exports.TOTAL_PAGE = exports.TOTAL = exports["default"] = void 0;

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var keys = Object.keys;
var BEGIN = '0';
exports.BEGIN = BEGIN;
var END = '1';
var PER_PAGE_NUM = 'perPageNum';
exports.PER_PAGE_NUM = PER_PAGE_NUM;
var TOTAL = 'total';
exports.TOTAL = TOTAL;
var TOTAL_PAGE = 'totalPage';
exports.TOTAL_PAGE = TOTAL_PAGE;
var CURRENT_PAGE = 'currentPage';
exports.CURRENT_PAGE = CURRENT_PAGE;
var BACKWARD = 'backward';
var FORWARD = 'forward';
var LAST_PAGE = 'lastPage';
var FIRST_PAGE = 'firstPage';
/**
 * type: [begin|page]
 */

var TYPE = 'type';
var TYPE_BEGIN = 'begin';
var TYPE_PAGE = 'page'; // url

var URL = 'url';
var QUERY_B = 'b';
var QUERY_PAGE = 'page';

var Page =
/*#__PURE__*/
function () {
  function Page(currentPage, url, cal) {
    (0, _classCallCheck2["default"])(this, Page);
    this[BEGIN] = null;
    this[END] = null;
    this[PER_PAGE_NUM] = null;
    this[TOTAL] = null;
    this[TOTAL_PAGE] = null;
    this[CURRENT_PAGE] = null;
    this[TYPE] = null;
    this[URL] = url || null; //nav

    this[BACKWARD] = null;
    this[FORWARD] = null;
    this[FIRST_PAGE] = null;
    this[LAST_PAGE] = null;

    if (null != currentPage) {
      // force use type with page. need let currentPage have value and begin keep null
      this[CURRENT_PAGE] = currentPage;
      cal.process(this, _objectSpread({}, cal.props, (0, _defineProperty2["default"])({}, BEGIN, null)));
    }
  }

  (0, _createClass2["default"])(Page, [{
    key: "set",
    value: function set(key, value) {
      this[key] = value;
    }
  }]);
  return Page;
}();

var paginationCalculator =
/*#__PURE__*/
function () {
  function paginationCalculator(props) {
    var _query, _objectSpread3;

    (0, _classCallCheck2["default"])(this, paginationCalculator);
    props = _objectSpread((_objectSpread3 = {}, (0, _defineProperty2["default"])(_objectSpread3, TOTAL, 0), (0, _defineProperty2["default"])(_objectSpread3, "query", (_query = {}, (0, _defineProperty2["default"])(_query, QUERY_B, QUERY_B), (0, _defineProperty2["default"])(_query, QUERY_PAGE, QUERY_PAGE), _query)), _objectSpread3), props);
    this.props = props;
  }

  (0, _createClass2["default"])(paginationCalculator, [{
    key: "set",
    value: function set(key, value) {
      this.props[key] = value;
    }
  }, {
    key: "sync",
    value: function sync(page, copyFrom) {
      var syncKeys = [PER_PAGE_NUM, TOTAL, CURRENT_PAGE, BEGIN];
      syncKeys.forEach(function (key) {
        if (null != copyFrom[key] && null == page[key]) {
          page.set(key, copyFrom[key]);
        }
      });
    }
  }, {
    key: "calBegin",
    value: function calBegin(page) {
      page[TOTAL_PAGE] = Math.ceil(page[TOTAL] / page[PER_PAGE_NUM]);

      if (isNaN(page[TOTAL_PAGE]) || 1 > page[TOTAL_PAGE]) {
        page[TOTAL_PAGE] = 1;
      }

      if (!page[CURRENT_PAGE] || 1 > page[CURRENT_PAGE]) {
        page[CURRENT_PAGE] = 1;
      }

      if (page[CURRENT_PAGE] > page[TOTAL_PAGE]) {
        page[CURRENT_PAGE] = page[TOTAL_PAGE];
      }

      page[BEGIN] = (page[CURRENT_PAGE] - 1) * page[PER_PAGE_NUM];
      page[END] = page[BEGIN] + page[PER_PAGE_NUM] - 1;

      if (page[BEGIN] >= page[TOTAL]) {
        page[BEGIN] = page[TOTAL] - 1;
      }

      if (page[END] >= page[TOTAL]) {
        page[END] = page[TOTAL] - 1;
      }

      return page;
    }
  }, {
    key: "calNav",
    value: function calNav(page) {
      if (1 !== page[CURRENT_PAGE]) {
        page[BACKWARD] = page[CURRENT_PAGE] - 1;
        page[FIRST_PAGE] = 1;
      }

      if (page[TOTAL_PAGE] > page[CURRENT_PAGE]) {
        page[FORWARD] = page[CURRENT_PAGE] + 1;
        page[LAST_PAGE] = page[TOTAL_PAGE];
      }
    }
  }, {
    key: "calPageList",
    value: function calPageList(page, num) {
      var _ref;

      if (num < 2) {
        console.error("Page list number need greater than 2, You set to [".concat(num, "]."));
        return;
      }

      var middle = Math.floor(num / 2);
      var begin = page[CURRENT_PAGE] - middle;

      if (begin <= 0) {
        begin = 1;
      }

      if (num % 2 === 0) {
        begin++;
      }

      var end = begin + num - 1;

      if (end > page[TOTAL_PAGE]) {
        end = page[TOTAL_PAGE];
      }

      if (end - begin < num - 1) {
        begin = end - num + 1;

        if (begin <= 0) {
          begin = 1;
        }
      }

      return _ref = {}, (0, _defineProperty2["default"])(_ref, BEGIN, begin), (0, _defineProperty2["default"])(_ref, END, end), _ref;
    }
  }, {
    key: "fixedPageList",
    value: function fixedPageList(_ref2) {
      var page = _ref2.page,
          pages = _ref2.pages,
          liCount = _ref2.liCount,
          num = _ref2.num;
      var list = keys(pages).map(function (key) {
        return pages[key];
      });

      if (num >= list.length) {
        return list;
      }

      var lastKey = list.length - 1;
      var start = 0;
      var end = undefined;

      if (page[LAST_PAGE]) {
        end = -3;
      }

      if (page[FIRST_PAGE] && liCount[BEGIN] > 2) {
        start = 2;
        end = -2;
      }

      if (list[lastKey][CURRENT_PAGE] === page[LAST_PAGE] || list[lastKey] === CURRENT_PAGE) {
        end = undefined;
      }

      return list.slice(start, end);
    }
  }, {
    key: "genPageList",
    value: function genPageList(num, page, url) {
      if (isNaN(num) || !num) {
        num = 10;
      }

      if (null == page) {
        page = this.process(new Page());
      }

      this.calNav(page);
      var result = (0, _defineProperty2["default"])({}, CURRENT_PAGE, page);
      var pages = {};
      var current = page[CURRENT_PAGE];
      var liCount = this.calPageList(page, num);

      for (var i = liCount[BEGIN], j = liCount[END]; i <= j; i++) {
        pages[i] = i !== current ? new Page(i, url, this) : CURRENT_PAGE;
      }

      if (page[FIRST_PAGE]) {
        if ((0, _getObjectValue["default"])(liCount, [BEGIN], -1) > page[FIRST_PAGE]) {
          var firstPage = new Page(page[FIRST_PAGE], url, this);

          if (2 === liCount[BEGIN]) {
            // index 1 is mean first page
            pages[1] = firstPage;
          } else {
            result[FIRST_PAGE] = firstPage;
          }
        }
      }

      if (page[FORWARD]) {
        result[CURRENT_PAGE][FORWARD] = new Page(page[FORWARD], url, this);
      }

      if (page[BACKWARD]) {
        result[CURRENT_PAGE][BACKWARD] = new Page(page[BACKWARD], url, this);
      }

      if (page && page[LAST_PAGE] && null == pages[page[LAST_PAGE]]) {
        var lastPage = new Page(page[LAST_PAGE], url, this);

        if (liCount[END] === page[LAST_PAGE]) {
          pages[liCount[END]] = lastPage;
        } else {
          result[LAST_PAGE] = lastPage;
        }
      }

      result.list = this.fixedPageList({
        page: page,
        pages: pages,
        num: num,
        liCount: liCount
      });
      return result;
    }
  }, {
    key: "process",
    value: function process(page, copyFrom) {
      if (null == page) {
        page = this.process(new Page());
      }

      if (null == copyFrom) {
        copyFrom = this.props;
      }

      this.sync(page, copyFrom);

      if (!page[PER_PAGE_NUM]) {
        console.error("Per page number can't set to empty.");
      }

      if (null != page[BEGIN]) {
        page[CURRENT_PAGE] = Math.floor(page[BEGIN] / page[PER_PAGE_NUM]) + 1;
        page[TYPE] = TYPE_BEGIN;
      } else if (null != page[CURRENT_PAGE]) {
        page[TYPE] = TYPE_PAGE;
      } else {
        page[CURRENT_PAGE] = 1;
        page[TYPE] = TYPE_PAGE;
      }

      return this.calBegin(page);
    }
  }]);
  return paginationCalculator;
}();

var _default = paginationCalculator;
exports["default"] = _default;