"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("reshow-runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("reshow-runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("reshow-runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactAtomicMolecule = require("react-atomic-molecule");

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

var _Dropdown = _interopRequireDefault(require("ricon/Dropdown"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var AccordionItem = function AccordionItem(_ref) {
  var title = _ref.title,
      content = _ref.content,
      iconLeft = _ref.iconLeft,
      iconRight = _ref.iconRight,
      titleClasses = _ref.titleClasses,
      contentClasses = _ref.contentClasses,
      onClick = _ref.onClick;
  return _react["default"].createElement(_reactAtomicMolecule.Item, null, _react["default"].createElement(_reactAtomicMolecule.Title, {
    onClick: onClick,
    className: titleClasses
  }, iconLeft, title, iconRight), _react["default"].createElement(_reactAtomicMolecule.Content, {
    className: contentClasses
  }, content));
};

var Accordion =
/*#__PURE__*/
function (_PureComponent) {
  (0, _inherits2["default"])(Accordion, _PureComponent);

  function Accordion() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Accordion);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Accordion)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      isActives: {}
    });
    return _this;
  }

  (0, _createClass2["default"])(Accordion, [{
    key: "handleClick",
    value: function handleClick(name) {
      this.setState(function (_ref2) {
        var isActives = _ref2.isActives;
        isActives[name] = !(0, _getObjectValue["default"])(isActives, [name], false);
        return _objectSpread({}, isActives);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          items = _this$props.items,
          iconLocRight = _this$props.iconLocRight,
          iconLocLeft = _this$props.iconLocLeft,
          iconOpen = _this$props.iconOpen,
          iconClose = _this$props.iconClose;
      var isActives = this.state.isActives;
      var classes = (0, _reactAtomicMolecule.mixClass)('accordion', className);
      return _react["default"].createElement(_reactAtomicMolecule.SemanticUI, {
        className: classes
      }, items.map(function (item, key) {
        var itemProps = (0, _getObjectValue["default"])(item, ['props'], {});
        var name = itemProps.name || key;
        var isActive = !!isActives[name];
        var titleClasses = (0, _reactAtomicMolecule.mixClass)({
          active: isActive
        });
        var contentClasses = (0, _reactAtomicMolecule.mixClass)({
          active: isActive
        });

        var icon = _react["default"].createElement(_reactAtomicMolecule.Icon, {
          style: Styles.icon
        }, isActive ? iconOpen : iconClose);

        var iconLeft;
        var iconRight;

        if (iconLocRight) {
          iconRight = icon;
        } else if (iconLocLeft) {
          iconLeft = icon;
        }

        return _react["default"].createElement(AccordionItem, _objectSpread({}, item, {
          name: name,
          titleClasses: titleClasses,
          contentClasses: contentClasses,
          iconLeft: iconLeft,
          iconRight: iconRight,
          key: name,
          onClick: _this2.handleClick.bind(_this2, name)
        }));
      }));
    }
  }]);
  return Accordion;
}(_react.PureComponent);

(0, _defineProperty2["default"])(Accordion, "defaultProps", {
  iconOpen: _react["default"].createElement(_Dropdown["default"], null),
  iconClose: _react["default"].createElement(_Dropdown["default"], {
    type: "left"
  }),
  iconLocRight: true,
  iconLocLeft: false
});
var _default = Accordion;
exports["default"] = _default;
var Styles = {
  icon: {
    width: 24,
    height: 24
  }
};
module.exports = exports.default;