"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("reshow-runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _reactAtomicMolecule = require("react-atomic-molecule");

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var _ref =
/*#__PURE__*/
_react["default"].createElement(_reactAtomicMolecule.SemanticUI, null, " / ");

var Breakcrumb = function Breakcrumb(props) {
  var className = props.className,
      children = props.children,
      divider = props.divider,
      dividerStyle = props.dividerStyle,
      style = props.style,
      reset = (0, _objectWithoutProperties2["default"])(props, ["className", "children", "divider", "dividerStyle", "style"]);
  var itemList = [];
  var defaultDivider = (0, _reactAtomicMolecule.build)(divider || _ref);

  _react.Children.forEach(children, function (node, k) {
    if (!node) {
      return;
    }

    var nodeProps = (0, _getObjectValue["default"])(node, ['props'], {});
    itemList.push((0, _reactAtomicMolecule.build)(node)({
      key: k,
      className: (0, _reactAtomicMolecule.mixClass)(nodeProps.className, 'section')
    }));
    var nodeDataDivider = nodeProps['data-divider'];
    var thisDivider = nodeDataDivider ? (0, _reactAtomicMolecule.build)(nodeDataDivider) : defaultDivider;
    var dividerProps = (0, _getObjectValue["default"])(divider, ['props'], function () {
      return (0, _getObjectValue["default"])(nodeProps.divider, ['props'], {});
    });
    itemList.push(thisDivider({
      key: k + '-div',
      style: _objectSpread({}, dividerProps.style, {}, dividerStyle),
      className: (0, _reactAtomicMolecule.mixClass)(dividerProps.className, 'divider')
    }));
  });

  if (itemList.length) {
    itemList.pop();
  }

  return _react["default"].createElement(_reactAtomicMolecule.SemanticUI, (0, _extends2["default"])({}, reset, {
    style: _objectSpread({}, Styles.container, {}, style),
    className: (0, _reactAtomicMolecule.mixClass)('breadcrumb', className)
  }), itemList);
};

var _default = Breakcrumb;
exports["default"] = _default;
var Styles = {
  container: {
    lineHeight: 1.8
  }
};
module.exports = exports.default;