"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.getHorizontalToVerticalMenu = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("reshow-runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("reshow-runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("reshow-runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactAtomicMolecule = require("react-atomic-molecule");

var _HamburgerToX = _interopRequireDefault(require("ricon/HamburgerToX"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var getHorizontalToVerticalMenu = function getHorizontalToVerticalMenu(Styles, merge) {
  var InjectStyles = {
    headerActive: [{
      maxHeight: '1000px !important'
    }, '.page-header.active'],
    navActive: [{
      display: 'block !important'
    }, '.page-header.active nav'],
    lgHeaderNav: [{
      display: ['inline-flex !important', '-webkit-inline-box !important', '-ms-inline-flexbox !important']
    }, [_reactAtomicMolecule.min.lg, '.page-header nav']],
    lgHamburgerIcon: [{
      display: 'none !important'
    }, [_reactAtomicMolecule.min.lg, '.page-header .hamburger-icon']]
  };

  if (merge) {
    (0, _reactAtomicMolecule.mergeStyleConfig)(Styles, defaultStyles, InjectStyles);
  }

  var HorizontalToVerticalMenu =
  /*#__PURE__*/
  function (_PureComponent) {
    (0, _inherits2["default"])(HorizontalToVerticalMenu, _PureComponent);

    function HorizontalToVerticalMenu(props) {
      var _this;

      (0, _classCallCheck2["default"])(this, HorizontalToVerticalMenu);
      _this = (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(HorizontalToVerticalMenu).call(this, props));
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
        on: false
      });
      (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleOn", function () {
        _this.setState(function (_ref) {
          var on = _ref.on;
          return {
            on: !on
          };
        });
      });
      injects = (0, _reactAtomicMolecule.lazyInject)(injects, InjectStyles);
      return _this;
    }

    (0, _createClass2["default"])(HorizontalToVerticalMenu, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        var _this$props = this.props,
            brand = _this$props.brand,
            component = _this$props.component,
            nav = _this$props.nav,
            style = _this$props.style,
            className = _this$props.className,
            children = _this$props.children,
            height = _this$props.height,
            others = (0, _objectWithoutProperties2["default"])(_this$props, ["brand", "component", "nav", "style", "className", "children", "height"]);
        var classes = (0, _reactAtomicMolecule.mixClass)(className, {
          active: this.state.on
        });
        var thisChildren = [];
        var build;

        if ((0, _react.isValidElement)(brand)) {
          thisChildren.push((0, _react.cloneElement)(brand, {
            style: _objectSpread({}, Styles.brand, {}, brand.props.style, {
              height: height
            }),
            className: (0, _reactAtomicMolecule.mixClass)(brand.props.className, 'brand'),
            key: 'brand'
          }));
        }

        if ((0, _react.isValidElement)(nav)) {
          thisChildren.push((0, _react.cloneElement)(nav, {
            style: _objectSpread({}, Styles.nav, {}, nav.props.style),
            className: (0, _reactAtomicMolecule.mixClass)('nav', nav.props.className),
            key: 'nav',
            handleOn: this.handleOn
          }));
        }

        _react.Children.forEach(children, function (child, key) {
          thisChildren.push((0, _react.cloneElement)(child, {
            key: key,
            handleOn: _this2.handleOn
          }));
        });

        if ((0, _react.isValidElement)(nav)) {
          thisChildren.push(_react["default"].createElement(_reactAtomicMolecule.Icon, {
            key: "hamburger-icon",
            className: "hamburger-icon",
            style: Styles.hamburgerIcon,
            onClick: this.handleOn
          }, _react["default"].createElement(_HamburgerToX["default"], {
            on: this.state.on
          })));
        }

        if ((0, _react.isValidElement)(component)) {
          build = _react.cloneElement;
        } else {
          build = _react.createElement;
        }

        return build(component, _objectSpread({}, others, {
          styles: (0, _reactAtomicMolecule.reactStyle)(_objectSpread({}, Styles.container, {}, style, {
            maxHeight: height,
            transition: [['padding 300ms linear', 'max-height 300ms ease-in-out'].join(', ')]
          }), null, false),
          className: classes
        }), thisChildren);
      }
    }]);
    return HorizontalToVerticalMenu;
  }(_react.PureComponent);

  (0, _defineProperty2["default"])(HorizontalToVerticalMenu, "defaultProps", {
    component: _reactAtomicMolecule.SemanticUI,
    brand: null,
    nav: null,
    height: 60
  });
  return HorizontalToVerticalMenu;
};

exports.getHorizontalToVerticalMenu = getHorizontalToVerticalMenu;
var injects;
var defaultStyles = {
  hamburgerIcon: {
    position: 'absolute',
    top: 10,
    right: 30,
    width: 35,
    height: 35,
    fill: '#fff',
    cursor: 'pointer'
  },
  container: {
    position: 'relative',
    maxHeight: 60,
    overflow: 'hidden',
    boxSizing: 'border-box'
  },
  nav: {
    display: 'none'
  }
};

var _default = getHorizontalToVerticalMenu(defaultStyles);

exports["default"] = _default;