"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("reshow-runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("reshow-runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("reshow-runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactAtomicMolecule = require("react-atomic-molecule");

var _toPercentJs = require("to-percent-js");

var _Pagination = _interopRequireDefault(require("../organisms/Pagination"));

var _paginationCalculator = _interopRequireWildcard(require("../../src/paginationCalculator"));

var PaginationController =
/*#__PURE__*/
function (_PureComponent) {
  (0, _inherits2["default"])(PaginationController, _PureComponent);

  function PaginationController() {
    (0, _classCallCheck2["default"])(this, PaginationController);
    return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(PaginationController).apply(this, arguments));
  }

  (0, _createClass2["default"])(PaginationController, [{
    key: "getPaginationData",
    value: function getPaginationData() {
      if (!this.cal) {
        this.cal = new _paginationCalculator["default"]();
      }

      var cal = this.cal;
      var _this$props = this.props,
          pageListNumber = _this$props.pageListNumber,
          total = _this$props.total,
          begin = _this$props.begin,
          currentPage = _this$props.currentPage,
          perPageNum = _this$props.perPageNum;
      cal.set(_paginationCalculator.TOTAL, (0, _toPercentJs.toInt)(total));

      if (null != perPageNum) {
        cal.set(_paginationCalculator.PER_PAGE_NUM, (0, _toPercentJs.toInt)(perPageNum));
      }

      if (null != begin) {
        cal.set(_paginationCalculator.BEGIN, (0, _toPercentJs.toInt)(begin));
      } else {
        cal.set(_paginationCalculator.CURRENT_PAGE, (0, _toPercentJs.toInt)(currentPage));
      }

      return cal.genPageList((0, _toPercentJs.toInt)(pageListNumber));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          onPageChange = _this$props2.onPageChange,
          pageListNumber = _this$props2.pageListNumber,
          total = _this$props2.total,
          begin = _this$props2.begin,
          currentPage = _this$props2.currentPage,
          perPageNum = _this$props2.perPageNum,
          otherProps = (0, _objectWithoutProperties2["default"])(_this$props2, ["onPageChange", "pageListNumber", "total", "begin", "currentPage", "perPageNum"]);
      var data = this.getPaginationData();
      return _react["default"].createElement(_reactAtomicMolecule.SemanticUI, otherProps, _react["default"].createElement(_Pagination["default"], (0, _extends2["default"])({}, data, {
        onPageChange: onPageChange
      })));
    }
  }]);
  return PaginationController;
}(_react.PureComponent);

(0, _defineProperty2["default"])(PaginationController, "defaultProps", {
  perPageNum: 10
});
var _default = PaginationController;
exports["default"] = _default;
module.exports = exports.default;