"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectField = exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("reshow-runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("reshow-runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("reshow-runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("reshow-runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactAtomicMolecule = require("react-atomic-molecule");

var _callFunc = _interopRequireDefault(require("call-func"));

var _Dropdown = _interopRequireDefault(require("../organisms/Dropdown"));

var Select =
/*#__PURE__*/
function (_PureComponent) {
  (0, _inherits2["default"])(Select, _PureComponent);

  function Select() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, Select);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(Select)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      value: null
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleSelect", function (item) {
      return function (e) {
        var _this$props = _this.props,
            labelLocator = _this$props.labelLocator,
            valueLocator = _this$props.valueLocator,
            onChange = _this$props.onChange;
        var value = valueLocator(item);
        var selected = labelLocator(item);

        _this.setState({
          value: value
        }, function () {
          (0, _callFunc["default"])(onChange, [value, {
            selected: selected,
            item: item
          }]);
        });
      };
    });
    return _this;
  }

  (0, _createClass2["default"])(Select, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          defaultValue = _this$props2.defaultValue,
          propsValue = _this$props2.value,
          labelLocator = _this$props2.labelLocator,
          valueLocator = _this$props2.valueLocator,
          placeholder = _this$props2.placeholder,
          options = _this$props2.options,
          name = _this$props2.name,
          onChange = _this$props2.onChange,
          props = (0, _objectWithoutProperties2["default"])(_this$props2, ["defaultValue", "value", "labelLocator", "valueLocator", "placeholder", "options", "name", "onChange"]);
      var value = this.state.value;
      var thisList = null;
      var thisPlaceholder = null;
      var thisSelected = value;

      if (placeholder) {
        thisPlaceholder = _react["default"].createElement(_reactAtomicMolecule.SemanticUI, {
          style: Styles.dropdownPlaceholder
        }, placeholder);
      }

      if (options) {
        thisList = _react["default"].createElement(_reactAtomicMolecule.Menu, null, options.map(function (l, key) {
          var optionValue = valueLocator(l);
          var optionText = labelLocator(l);
          var optionClasses = null;

          if (value === optionValue) {
            thisSelected = optionText;
            optionClasses = 'active';
          }

          return _react["default"].createElement(_reactAtomicMolecule.Item, {
            onClick: _this2.handleSelect(l),
            "data-v": optionValue,
            key: key,
            className: optionClasses
          }, optionText);
        }));
      }

      var title = thisSelected || thisPlaceholder;
      return _react["default"].createElement(_Dropdown["default"], (0, _extends2["default"])({}, props, {
        list: thisList
      }), _react["default"].createElement("input", {
        type: "hidden",
        name: name,
        value: value || ''
      }), title);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var value = nextProps.value,
          defaultValue = nextProps.defaultValue;
      var prevValue = prevState.prevValue;
      var thisValue = value || defaultValue;

      if (thisValue !== prevValue) {
        return {
          value: thisValue,
          prevValue: thisValue
        };
      }

      return null;
    }
  }]);
  return Select;
}(_react.PureComponent);

(0, _defineProperty2["default"])(Select, "defaultProps", {
  labelLocator: function labelLocator(d) {
    return d.label;
  },
  valueLocator: function valueLocator(d) {
    return d.value;
  },
  simple: false
});

var SelectField = function SelectField(props) {
  return _react["default"].createElement(_reactAtomicMolecule.Field, (0, _extends2["default"])({}, props, {
    inputComponent: _react["default"].createElement(Select, {
      titleStyle: Styles.dropdownTitle,
      style: Styles.dropdown,
      iconStyle: Styles.dropdownIcon
    })
  }));
};

exports.SelectField = SelectField;
var _default = Select;
exports["default"] = _default;
var Styles = {
  dropdown: {
    border: '1px solid rgba(34,36,38,.15)',
    minHeight: 40
  },
  dropdownTitle: {
    paddingLeft: 10
  },
  dropdownPlaceholder: {
    color: '#ccc'
  },
  dropdownIcon: {
    fill: '#ccc'
  }
};