"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("reshow-runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("reshow-runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _reactAtomicMolecule = require("react-atomic-molecule");

var _HamburgerToArrow = _interopRequireDefault(require("ricon/HamburgerToArrow"));

var _reshowFlux = require("reshow-flux");

var _getObjectValue = _interopRequireWildcard(require("get-object-value"));

var _classLib = require("class-lib");

var _cssQuerySelector = require("css-query-selector");

var _getoffset = _interopRequireDefault(require("getoffset"));

var _callFunc = _interopRequireDefault(require("call-func"));

var _index = require("../../src/index");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var keys = Object.keys;

var getMenuByArray = function getMenuByArray(onClick) {
  return function (arr, component, active, menuOrder) {
    if (!arr) {
      return null;
    }

    var results = [];
    var buildComp = (0, _reactAtomicMolecule.build)(component);

    if (!menuOrder) {
      menuOrder = keys(arr);
    }

    menuOrder.forEach(function (key) {
      var _arr$key = arr[key],
          href = _arr$key.href,
          text = _arr$key.text,
          className = _arr$key.className,
          others = (0, _objectWithoutProperties2["default"])(_arr$key, ["href", "text", "className"]);
      var classes = (0, _reactAtomicMolecule.mixClass)(className, 'item', {
        active: active === key
      });
      results.push(buildComp(_objectSpread({}, others, {
        key: key,
        href: href,
        name: key,
        className: classes,
        onClick: onClick
      }), text));
    });
    return results;
  };
};

var DefaultIcon = function DefaultIcon(_ref) {
  var className = _ref.className,
      on = _ref.on,
      right = _ref.right,
      onClick = _ref.onClick,
      iconStyle = _ref.iconStyle,
      hamburgerStyle = _ref.hamburgerStyle;
  return _react["default"].createElement(_reactAtomicMolecule.Icon, {
    onClick: onClick,
    className: (0, _reactAtomicMolecule.mixClass)(className, 'hamburger-icon'),
    styles: (0, _reactAtomicMolecule.reactStyle)(_objectSpread({}, Styles.icon, {}, iconStyle), false, false)
  }, _react["default"].createElement(_HamburgerToArrow["default"], {
    on: on,
    right: right,
    styles: (0, _reactAtomicMolecule.reactStyle)(_objectSpread({}, Styles.hamburger, {}, hamburgerStyle), false, false)
  }));
};

var _ref2 =
/*#__PURE__*/
_react["default"].createElement(DefaultIcon, null);

var _ref3 =
/*#__PURE__*/
_react["default"].createElement(DefaultIcon, null);

var SideMenu =
/*#__PURE__*/
function (_PureComponent) {
  (0, _inherits2["default"])(SideMenu, _PureComponent);

  function SideMenu() {
    (0, _classCallCheck2["default"])(this, SideMenu);
    return (0, _possibleConstructorReturn2["default"])(this, (0, _getPrototypeOf2["default"])(SideMenu).apply(this, arguments));
  }

  (0, _createClass2["default"])(SideMenu, [{
    key: "getRoot",
    value: function getRoot() {
      var root = this.props.root;
      var thisRoot = root;

      if (!thisRoot) {
        thisRoot = document.body;
      }

      return thisRoot;
    }
  }, {
    key: "updateRoot",
    value: function updateRoot(on) {
      var _this$props = this.props,
          rootActiveClass = _this$props.rootActiveClass,
          rootInactiveClass = _this$props.rootInactiveClass;
      var thisRoot = this.getRoot();

      if (!thisRoot) {
        console.wanr('root not found');
        return;
      }

      if (on) {
        thisRoot.className = (0, _reactAtomicMolecule.mixClass)(thisRoot.className, rootActiveClass);
        thisRoot.className = (0, _classLib.removeClass)(thisRoot.className, rootInactiveClass);
      } else {
        thisRoot.className = (0, _reactAtomicMolecule.mixClass)(thisRoot.className, rootInactiveClass);
        thisRoot.className = (0, _classLib.removeClass)(thisRoot.className, rootActiveClass);
      }
    }
  }, {
    key: "handleSwitch",
    value: function handleSwitch(stateOn, e) {
      var _this$props2 = this.props,
          id = _this$props2.id,
          onSwitch = _this$props2.onSwitch;
      var isValidStateOn = 'boolean' === typeof stateOn;
      var on = !(isValidStateOn ? stateOn : this.state.on);
      var defaultOff = (0, _getoffset["default"])((0, _cssQuerySelector.queryOne)('.sidebar .default-off'));
      var isSet = isValidStateOn || defaultOff.w && defaultOff.h;

      if (isSet) {
        (0, _index.navigationDispatch)({
          id: id,
          params: {
            on: on
          }
        });
      }

      (0, _callFunc["default"])(onSwitch, [e, on, isSet]);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var on = this.state.on;

      if ('undefined' !== typeof on) {
        this.updateRoot(on);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var on = this.state.on;

      if (on !== prevState.on) {
        this.updateRoot(on);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$props3 = this.props,
          rootActiveClass = _this$props3.rootActiveClass,
          rootInactiveClass = _this$props3.rootInactiveClass;
      var thisRoot = this.getRoot();
      thisRoot.className = (0, _classLib.removeClass)(thisRoot.className, rootActiveClass);
      thisRoot.className = (0, _classLib.removeClass)(thisRoot.className, rootInactiveClass);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          onSwitch = _this$props4.onSwitch,
          fixedMini = _this$props4.fixedMini,
          defaultOnIcon = _this$props4.defaultOnIcon,
          defaultOffIcon = _this$props4.defaultOffIcon,
          iconStyle = _this$props4.iconStyle,
          hamburgerStyle = _this$props4.hamburgerStyle,
          component = _this$props4.component,
          linkComponent = _this$props4.linkComponent,
          className = _this$props4.className,
          menus = _this$props4.menus,
          menuOrder = _this$props4.menuOrder,
          root = _this$props4.root,
          rootActiveClass = _this$props4.rootActiveClass,
          rootInactiveClass = _this$props4.rootInactiveClass,
          others = (0, _objectWithoutProperties2["default"])(_this$props4, ["onSwitch", "fixedMini", "defaultOnIcon", "defaultOffIcon", "iconStyle", "hamburgerStyle", "component", "linkComponent", "className", "menus", "menuOrder", "root", "rootActiveClass", "rootInactiveClass"]);
      var _this$state = this.state,
          activeMenu = _this$state.activeMenu,
          on = _this$state.on;
      var isInit = !on && false !== on;
      var menuItems = getMenuByArray(this.handleSwitch.bind(this, null))((0, _getObjectValue.toJS)(menus), linkComponent, activeMenu, (0, _getObjectValue.toJS)(menuOrder));
      var menuElement = (0, _reactAtomicMolecule.build)(component)(others, menuItems);
      var thisDefaultOnIcon = null;
      var thisDefaultOffIcon = defaultOffIcon;
      var defaultOff = isInit ? false : on;

      if (!thisDefaultOffIcon) {
        thisDefaultOffIcon = _ref2;
      }

      thisDefaultOffIcon = (0, _react.cloneElement)(thisDefaultOffIcon, {
        on: defaultOff,
        onClick: this.handleSwitch.bind(this, defaultOff),
        className: 'default-off',
        iconStyle: iconStyle,
        hamburgerStyle: hamburgerStyle
      });

      if (!fixedMini) {
        var defaultOn = isInit ? true : on;
        thisDefaultOnIcon = defaultOnIcon;

        if (!thisDefaultOnIcon) {
          thisDefaultOnIcon = _ref3;
        }

        thisDefaultOnIcon = (0, _react.cloneElement)(thisDefaultOnIcon, {
          on: true,
          right: !defaultOn,
          onClick: this.handleSwitch.bind(this, defaultOn),
          className: 'default-on',
          iconStyle: iconStyle,
          hamburgerStyle: hamburgerStyle
        });
      }

      var classes = (0, _reactAtomicMolecule.mixClass)({
        active: on,
        inactive: on === false
      }, 'sidebar', className);
      return _react["default"].createElement(_reactAtomicMolecule.Rail, {
        className: classes
      }, menuElement, thisDefaultOnIcon, thisDefaultOffIcon);
    }
  }], [{
    key: "getStores",
    value: function getStores() {
      return [_index.navigationStore];
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var on = nextProps.on;

      if (on !== prevState.prePropsOn) {
        return {
          on: on,
          prePropsOn: on
        };
      } else {
        return null;
      }
    }
  }, {
    key: "calculateState",
    value: function calculateState(prevState, props) {
      var id = (0, _getObjectValue["default"])(props, ['id'], 'default');

      var state = _index.navigationStore.getState();

      var settings = state.get(id);
      var storeOn = (0, _getObjectValue["default"])(settings, ['on']);
      var on;

      if ('undefined' === typeof storeOn) {
        on = prevState.on;
      } else {
        on = storeOn;
      }

      return {
        on: on,
        activeMenu: (0, _getObjectValue["default"])(settings, ['activeMenu'])
      };
    }
  }]);
  return SideMenu;
}(_react.PureComponent);

(0, _defineProperty2["default"])(SideMenu, "defaultProps", {
  component: _reactAtomicMolecule.SemanticUI,
  linkComponent: 'a',
  menus: [],
  root: null,
  rootActiveClass: 'side-menu-active',
  rootInactiveClass: 'side-menu-inactive'
});

var _default = (0, _reshowFlux.connect)(SideMenu, {
  withProps: true
});

exports["default"] = _default;
var Styles = {
  icon: {
    background: '#000',
    padding: 5,
    width: 24,
    height: 24,
    position: 'fixed',
    top: 0,
    left: 0,
    zIndex: 1,
    cursor: 'pointer',
    opacity: '.5',
    transition: ['all 0.2s ease-out']
  },
  hamburger: {
    fill: '#fff'
  }
};
module.exports = exports.default;