"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("reshow-runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("reshow-runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("reshow-runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("reshow-runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("reshow-runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("reshow-runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactAtomicMolecule = require("react-atomic-molecule");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var TabView =
/*#__PURE__*/
function (_PureComponent) {
  (0, _inherits2["default"])(TabView, _PureComponent);

  function TabView() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2["default"])(this, TabView);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2["default"])(this, (_getPrototypeOf2 = (0, _getPrototypeOf3["default"])(TabView)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {});
    return _this;
  }

  (0, _createClass2["default"])(TabView, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          id = _this$props.id,
          style = _this$props.style,
          contentStyle = _this$props.contentStyle,
          menuStyle = _this$props.menuStyle,
          menu = _this$props.menu,
          body = _this$props.body,
          disableSwitch = _this$props.disableSwitch,
          stackable = _this$props.stackable,
          rightMenu = _this$props.rightMenu,
          bottom = _this$props.bottom,
          left = _this$props.left,
          right = _this$props.right,
          props = (0, _objectWithoutProperties2["default"])(_this$props, ["id", "style", "contentStyle", "menuStyle", "menu", "body", "disableSwitch", "stackable", "rightMenu", "bottom", "left", "right"]);
      var tabMenuItems = [];
      var stateSelected = this.state.selected;
      var contentView = null;
      var content = null;
      var tabMenu;

      _react.Children.map(props.children, function (item, itemKey) {
        var itemProps = item.props; // detect selected

        var nodeKey = itemProps.name || itemKey;

        if (true === stateSelected) {
          stateSelected = nodeKey;
        }

        var selected = nodeKey === stateSelected;

        _react.Children.map(itemProps.children, function (node, index) {
          if (index % 2 || 1 === _react.Children.count(itemProps.children)) {
            var nodeProps = node.props;
            var nodeClasses = (0, _reactAtomicMolecule.mixClass)(nodeProps.className, 'item', {
              active: selected
            });
            node = (0, _reactAtomicMolecule.build)(node)({
              key: nodeKey,
              selected: selected,
              className: nodeClasses,
              style: _objectSpread({}, Styles.tabItem, {}, nodeProps.style),
              onClickCapture: function onClickCapture(e) {
                if (!disableSwitch) {
                  if (!nodeProps.disableSwitch) {
                    _this2.setState({
                      selected: nodeKey
                    });
                  }
                }

                if (props.onTabItemPress) {
                  props.onTabItemPress(nodeKey);
                }
              }
            });
            tabMenuItems.push(node);
          } else {
            if (selected) {
              contentView = node;
            }
          }
        });
      }); // Tab Menu


      if (rightMenu) {
        tabMenuItems.push((0, _reactAtomicMolecule.build)(rightMenu)({
          key: 'r-menu'
        }));
      }

      var menuOpt = {
        top: !bottom && !left && !right,
        bottom: bottom,
        vertical: left || right,
        stackable: stackable
      };
      var menuClasses = (0, _reactAtomicMolecule.mixClass)('attached tabular menu', menuOpt);
      tabMenu = (0, _reactAtomicMolecule.build)(menu)({
        key: 'menu',
        style: menuStyle,
        className: menuClasses
      }, tabMenuItems);

      if (contentView) {
        // Tab Body
        var contentClasses = (0, _reactAtomicMolecule.mixClass)('attached tab segment active', {
          top: !menuOpt.top,
          bottom: menuOpt.top
        });
        content = (0, _reactAtomicMolecule.build)(body)({
          key: 'content',
          style: _objectSpread({}, Styles.tabBody, {}, contentStyle),
          className: contentClasses
        }, contentView);
      }

      var childOrder = menuOpt.top ? [tabMenu, content] : [content, tabMenu];
      return _react["default"].createElement(_reactAtomicMolecule.SemanticUI, {
        style: style,
        id: id
      }, childOrder);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(_ref, _ref2) {
      var selected = _ref.selected;
      var lastPropsSelected = _ref2.lastPropsSelected;

      if (lastPropsSelected !== selected) {
        return {
          lastPropsSelected: selected,
          selected: selected
        };
      } else {
        return null;
      }
    }
  }]);
  return TabView;
}(_react.PureComponent);

(0, _defineProperty2["default"])(TabView, "defaultProps", {
  disableSwitch: false,
  stackable: true,
  selected: true,
  body: _reactAtomicMolecule.SemanticUI,
  menu: _reactAtomicMolecule.SemanticUI
});
var _default = TabView;
exports["default"] = _default;
var Styles = {
  tabBody: {
    boxSizing: 'border-box'
  },
  tabItem: {
    boxSizing: 'border-box',
    cursor: 'pointer'
  }
};
module.exports = exports.default;