import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { PureComponent } from 'react';
import { mixClass, Icon, SemanticUI, Item, Title, Content } from 'react-atomic-molecule';
import get from 'get-object-value';
import Dropdown from 'ricon/Dropdown';

var AccordionItem = function AccordionItem(_ref) {
  var title = _ref.title,
      content = _ref.content,
      iconLeft = _ref.iconLeft,
      iconRight = _ref.iconRight,
      titleClasses = _ref.titleClasses,
      contentClasses = _ref.contentClasses,
      onClick = _ref.onClick;
  return React.createElement(Item, null, React.createElement(Title, {
    onClick: onClick,
    className: titleClasses
  }, iconLeft, title, iconRight), React.createElement(Content, {
    className: contentClasses
  }, content));
};

var Accordion =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(Accordion, _PureComponent);

  function Accordion() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Accordion);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Accordion)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      isActives: {}
    });

    return _this;
  }

  _createClass(Accordion, [{
    key: "handleClick",
    value: function handleClick(name) {
      this.setState(function (_ref2) {
        var isActives = _ref2.isActives;
        isActives[name] = !get(isActives, [name], false);
        return _objectSpread({}, isActives);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          items = _this$props.items,
          iconLocRight = _this$props.iconLocRight,
          iconLocLeft = _this$props.iconLocLeft,
          iconOpen = _this$props.iconOpen,
          iconClose = _this$props.iconClose;
      var isActives = this.state.isActives;
      var classes = mixClass('accordion', className);
      return React.createElement(SemanticUI, {
        className: classes
      }, items.map(function (item, key) {
        var itemProps = get(item, ['props'], {});
        var name = itemProps.name || key;
        var isActive = !!isActives[name];
        var titleClasses = mixClass({
          active: isActive
        });
        var contentClasses = mixClass({
          active: isActive
        });
        var icon = React.createElement(Icon, {
          style: Styles.icon
        }, isActive ? iconOpen : iconClose);
        var iconLeft;
        var iconRight;

        if (iconLocRight) {
          iconRight = icon;
        } else if (iconLocLeft) {
          iconLeft = icon;
        }

        return React.createElement(AccordionItem, _objectSpread({}, item, {
          name: name,
          titleClasses: titleClasses,
          contentClasses: contentClasses,
          iconLeft: iconLeft,
          iconRight: iconRight,
          key: name,
          onClick: _this2.handleClick.bind(_this2, name)
        }));
      }));
    }
  }]);

  return Accordion;
}(PureComponent);

_defineProperty(Accordion, "defaultProps", {
  iconOpen: React.createElement(Dropdown, null),
  iconClose: React.createElement(Dropdown, {
    type: "left"
  }),
  iconLocRight: true,
  iconLocLeft: false
});

export default Accordion;
var Styles = {
  icon: {
    width: 24,
    height: 24
  }
};