import _extends from "reshow-runtime/es/helpers/extends";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { Children } from 'react';
import { build, mixClass, SemanticUI } from 'react-atomic-molecule';
import get from 'get-object-value';

var _ref =
/*#__PURE__*/
React.createElement(SemanticUI, null, " / ");

var Breakcrumb = function Breakcrumb(props) {
  var className = props.className,
      children = props.children,
      divider = props.divider,
      dividerStyle = props.dividerStyle,
      style = props.style,
      reset = _objectWithoutProperties(props, ["className", "children", "divider", "dividerStyle", "style"]);

  var itemList = [];
  var defaultDivider = build(divider || _ref);
  Children.forEach(children, function (node, k) {
    if (!node) {
      return;
    }

    var nodeProps = get(node, ['props'], {});
    itemList.push(build(node)({
      key: k,
      className: mixClass(nodeProps.className, 'section')
    }));
    var nodeDataDivider = nodeProps['data-divider'];
    var thisDivider = nodeDataDivider ? build(nodeDataDivider) : defaultDivider;
    var dividerProps = get(divider, ['props'], function () {
      return get(nodeProps.divider, ['props'], {});
    });
    itemList.push(thisDivider({
      key: k + '-div',
      style: _objectSpread({}, dividerProps.style, {}, dividerStyle),
      className: mixClass(dividerProps.className, 'divider')
    }));
  });

  if (itemList.length) {
    itemList.pop();
  }

  return React.createElement(SemanticUI, _extends({}, reset, {
    style: _objectSpread({}, Styles.container, {}, style),
    className: mixClass('breadcrumb', className)
  }), itemList);
};

export default Breakcrumb;
var Styles = {
  container: {
    lineHeight: 1.8
  }
};