import _extends from "reshow-runtime/es/helpers/extends";
import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { cloneElement, isValidElement, PureComponent } from 'react';
import get from 'get-object-value';
import { lazyInject, mixClass, SemanticUI, Icon, Menu, Item } from 'react-atomic-molecule';
import DropdownIcon from 'ricon/Dropdown';
import { doc } from 'win-doc';

var body = function body() {
  return doc().body;
};

var _ref =
/*#__PURE__*/
React.createElement(DropdownIcon, null);

var Dropdown =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(Dropdown, _PureComponent);

  _createClass(Dropdown, [{
    key: "open",
    value: function open() {
      var _this2 = this;

      var simple = this.props.simple;
      var listStyle = {};

      if (simple) {
        listStyle.visibility = 'hidden';
        this.titleTimer = setTimeout(function () {
          listStyle.visibility = 'inherit';

          _this2.setState({
            listStyle: _objectSpread({}, listStyle)
          });
        }, 300);
      } else {
        body().addEventListener('click', this.handleClose);
        listStyle.display = 'block';
      }

      this.setState({
        listStyle: listStyle
      });
    }
  }, {
    key: "close",
    value: function close() {
      var simple = this.props.simple;

      if (!simple) {
        body().removeEventListener('click', this.handleClose);
      }

      this.setState({
        listStyle: {}
      });
    }
  }]);

  function Dropdown(props) {
    var _this;

    _classCallCheck(this, Dropdown);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Dropdown).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "menuTimer", null);

    _defineProperty(_assertThisInitialized(_this), "titleTimer", null);

    _defineProperty(_assertThisInitialized(_this), "state", {
      listStyle: {},
      hideList: false
    });

    _defineProperty(_assertThisInitialized(_this), "handleTitleClick", function (e) {
      var listStyle = _this.state.listStyle;

      if (listStyle.display === 'block') {
        _this.close();
      } else {
        _this.open();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleMenuClick", function () {
      var simple = _this.props.simple;

      if (simple) {
        setTimeout(function () {
          if ('hidden' !== get(_assertThisInitialized(_this), ['state', 'listStyle', 'visibility'])) {
            _this.setState({
              hideList: true
            });

            _this.menuTimer = setTimeout(function () {
              return _this.setState({
                hideList: false
              });
            }, 300);
          }
        });
      } else {
        _this.close();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleClose", function (e) {
      var target = e.target;

      if (_this.menu.contains(target)) {
        return;
      }

      _this.close();
    });

    injects = lazyInject(injects, InjectStyles);
    return _this;
  }

  _createClass(Dropdown, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.titleTimer) {
        clearTimeout(this.titleTimer);
      }

      if (this.menuTimer) {
        clearTimeout(this.menuTimer);
      }

      var simple = this.props.simple;

      if (!simple) {
        body().removeEventListener('click', this.handleClose);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          list = _this$props.list,
          listStyle = _this$props.listStyle,
          titleStyle = _this$props.titleStyle,
          iconStyle = _this$props.iconStyle,
          icon = _this$props.icon,
          children = _this$props.children,
          style = _this$props.style,
          className = _this$props.className,
          simple = _this$props.simple,
          props = _objectWithoutProperties(_this$props, ["list", "listStyle", "titleStyle", "iconStyle", "icon", "children", "style", "className", "simple"]);

      var _this$state = this.state,
          stateListStyle = _this$state.listStyle,
          hideList = _this$state.hideList;
      var thisList = null;

      if (!hideList && list) {
        thisList = cloneElement(list, {
          style: _objectSpread({}, Styles.list, {}, listStyle, {}, stateListStyle),
          onClick: this.handleMenuClick
        });
      }

      var thisIcon = null;

      if (icon) {
        if (!isValidElement(icon)) {
          thisIcon = React.createElement(Icon, {
            className: "dropdown-default-icon",
            style: _objectSpread({}, Styles.icon, {}, iconStyle)
          }, _ref);
        } else {
          thisIcon = icon;
        }
      }

      var classes = mixClass(className, 'compact');
      var titleClasses = mixClass('dropdown', {
        simple: simple
      });
      return React.createElement(Menu, _extends({}, props, {
        style: _objectSpread({}, Styles.container, {}, style),
        className: classes,
        refCb: function refCb(el) {
          return _this3.menu = el;
        },
        onClick: this.handleTitleClick
      }), React.createElement(Item, {
        className: titleClasses,
        style: _objectSpread({}, Styles.title, {}, titleStyle)
      }, React.createElement(SemanticUI, {
        style: Styles.label
      }, children, thisIcon), thisList));
    }
  }]);

  return Dropdown;
}(PureComponent);

_defineProperty(Dropdown, "defaultProps", {
  icon: true,
  simple: true
});

export default Dropdown;
var Styles = {
  container: {
    border: 'none',
    boxShadow: 'none',
    minHeight: 'auto',
    background: 'none'
  },
  title: {
    padding: 0
  },
  label: {
    display: 'inherit'
  },
  icon: {
    width: 24,
    height: 24,
    marginTop: -5
  },
  list: {
    marginTop: -1,
    //aviod not expected hover out
    maxHeight: '50vh',
    overflow: 'auto'
  }
};
var injects;
var InjectStyles = {
  defaultIcon: [{
    transform: ['rotate(180deg)']
  }, '.ui.simple.dropdown:hover .dropdown-default-icon'],
  initMenu: [{
    display: 'none !important'
  }, '.ui.simple.dropdown .menu'],
  hoverMenu: [{
    display: 'block !important'
  }, ['.ui.simple.active.dropdown>.menu', '.ui.simple.dropdown:hover>.menu'].join(',')]
};