import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { cloneElement, createElement, isValidElement, Children, PureComponent } from 'react';
import { min, lazyInject, mixClass, mergeStyleConfig, reactStyle, Icon, SemanticUI } from 'react-atomic-molecule';
import HamburgerIcon from 'ricon/HamburgerToX';
export var getHorizontalToVerticalMenu = function getHorizontalToVerticalMenu(Styles, merge) {
  var InjectStyles = {
    headerActive: [{
      maxHeight: '1000px !important'
    }, '.page-header.active'],
    navActive: [{
      display: 'block !important'
    }, '.page-header.active nav'],
    lgHeaderNav: [{
      display: ['inline-flex !important', '-webkit-inline-box !important', '-ms-inline-flexbox !important']
    }, [min.lg, '.page-header nav']],
    lgHamburgerIcon: [{
      display: 'none !important'
    }, [min.lg, '.page-header .hamburger-icon']]
  };

  if (merge) {
    mergeStyleConfig(Styles, defaultStyles, InjectStyles);
  }

  var HorizontalToVerticalMenu =
  /*#__PURE__*/
  function (_PureComponent) {
    _inherits(HorizontalToVerticalMenu, _PureComponent);

    function HorizontalToVerticalMenu(props) {
      var _this;

      _classCallCheck(this, HorizontalToVerticalMenu);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(HorizontalToVerticalMenu).call(this, props));

      _defineProperty(_assertThisInitialized(_this), "state", {
        on: false
      });

      _defineProperty(_assertThisInitialized(_this), "handleOn", function () {
        _this.setState(function (_ref) {
          var on = _ref.on;
          return {
            on: !on
          };
        });
      });

      injects = lazyInject(injects, InjectStyles);
      return _this;
    }

    _createClass(HorizontalToVerticalMenu, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        var _this$props = this.props,
            brand = _this$props.brand,
            component = _this$props.component,
            nav = _this$props.nav,
            style = _this$props.style,
            className = _this$props.className,
            children = _this$props.children,
            height = _this$props.height,
            others = _objectWithoutProperties(_this$props, ["brand", "component", "nav", "style", "className", "children", "height"]);

        var classes = mixClass(className, {
          active: this.state.on
        });
        var thisChildren = [];
        var build;

        if (isValidElement(brand)) {
          thisChildren.push(cloneElement(brand, {
            style: _objectSpread({}, Styles.brand, {}, brand.props.style, {
              height: height
            }),
            className: mixClass(brand.props.className, 'brand'),
            key: 'brand'
          }));
        }

        if (isValidElement(nav)) {
          thisChildren.push(cloneElement(nav, {
            style: _objectSpread({}, Styles.nav, {}, nav.props.style),
            className: mixClass('nav', nav.props.className),
            key: 'nav',
            handleOn: this.handleOn
          }));
        }

        Children.forEach(children, function (child, key) {
          thisChildren.push(cloneElement(child, {
            key: key,
            handleOn: _this2.handleOn
          }));
        });

        if (isValidElement(nav)) {
          thisChildren.push(React.createElement(Icon, {
            key: "hamburger-icon",
            className: "hamburger-icon",
            style: Styles.hamburgerIcon,
            onClick: this.handleOn
          }, React.createElement(HamburgerIcon, {
            on: this.state.on
          })));
        }

        if (isValidElement(component)) {
          build = cloneElement;
        } else {
          build = createElement;
        }

        return build(component, _objectSpread({}, others, {
          styles: reactStyle(_objectSpread({}, Styles.container, {}, style, {
            maxHeight: height,
            transition: [['padding 300ms linear', 'max-height 300ms ease-in-out'].join(', ')]
          }), null, false),
          className: classes
        }), thisChildren);
      }
    }]);

    return HorizontalToVerticalMenu;
  }(PureComponent);

  _defineProperty(HorizontalToVerticalMenu, "defaultProps", {
    component: SemanticUI,
    brand: null,
    nav: null,
    height: 60
  });

  return HorizontalToVerticalMenu;
};
var injects;
var defaultStyles = {
  hamburgerIcon: {
    position: 'absolute',
    top: 10,
    right: 30,
    width: 35,
    height: 35,
    fill: '#fff',
    cursor: 'pointer'
  },
  container: {
    position: 'relative',
    maxHeight: 60,
    overflow: 'hidden',
    boxSizing: 'border-box'
  },
  nav: {
    display: 'none'
  }
};
export default getHorizontalToVerticalMenu(defaultStyles);