import _extends from "reshow-runtime/es/helpers/extends";
import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import React, { PureComponent } from 'react';
import { SemanticUI } from 'react-atomic-molecule';
import { toInt } from 'to-percent-js';
import Pagination from '../organisms/Pagination';
import paginationCalculator, { TOTAL, BEGIN, CURRENT_PAGE, PER_PAGE_NUM } from '../../src/paginationCalculator';

var PaginationController =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(PaginationController, _PureComponent);

  function PaginationController() {
    _classCallCheck(this, PaginationController);

    return _possibleConstructorReturn(this, _getPrototypeOf(PaginationController).apply(this, arguments));
  }

  _createClass(PaginationController, [{
    key: "getPaginationData",
    value: function getPaginationData() {
      if (!this.cal) {
        this.cal = new paginationCalculator();
      }

      var cal = this.cal;
      var _this$props = this.props,
          pageListNumber = _this$props.pageListNumber,
          total = _this$props.total,
          begin = _this$props.begin,
          currentPage = _this$props.currentPage,
          perPageNum = _this$props.perPageNum;
      cal.set(TOTAL, toInt(total));

      if (null != perPageNum) {
        cal.set(PER_PAGE_NUM, toInt(perPageNum));
      }

      if (null != begin) {
        cal.set(BEGIN, toInt(begin));
      } else {
        cal.set(CURRENT_PAGE, toInt(currentPage));
      }

      return cal.genPageList(toInt(pageListNumber));
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          onPageChange = _this$props2.onPageChange,
          pageListNumber = _this$props2.pageListNumber,
          total = _this$props2.total,
          begin = _this$props2.begin,
          currentPage = _this$props2.currentPage,
          perPageNum = _this$props2.perPageNum,
          otherProps = _objectWithoutProperties(_this$props2, ["onPageChange", "pageListNumber", "total", "begin", "currentPage", "perPageNum"]);

      var data = this.getPaginationData();
      return React.createElement(SemanticUI, otherProps, React.createElement(Pagination, _extends({}, data, {
        onPageChange: onPageChange
      })));
    }
  }]);

  return PaginationController;
}(PureComponent);

_defineProperty(PaginationController, "defaultProps", {
  perPageNum: 10
});

export default PaginationController;