import _extends from "reshow-runtime/es/helpers/extends";
import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import React, { PureComponent } from 'react';
import { Field, Menu, Item, SemanticUI } from 'react-atomic-molecule';
import callfunc from 'call-func';
import Dropdown from '../organisms/Dropdown';

var Select =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(Select, _PureComponent);

  function Select() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Select)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      value: null
    });

    _defineProperty(_assertThisInitialized(_this), "handleSelect", function (item) {
      return function (e) {
        var _this$props = _this.props,
            labelLocator = _this$props.labelLocator,
            valueLocator = _this$props.valueLocator,
            onChange = _this$props.onChange;
        var value = valueLocator(item);
        var selected = labelLocator(item);

        _this.setState({
          value: value
        }, function () {
          callfunc(onChange, [value, {
            selected: selected,
            item: item
          }]);
        });
      };
    });

    return _this;
  }

  _createClass(Select, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          defaultValue = _this$props2.defaultValue,
          propsValue = _this$props2.value,
          labelLocator = _this$props2.labelLocator,
          valueLocator = _this$props2.valueLocator,
          placeholder = _this$props2.placeholder,
          options = _this$props2.options,
          name = _this$props2.name,
          onChange = _this$props2.onChange,
          props = _objectWithoutProperties(_this$props2, ["defaultValue", "value", "labelLocator", "valueLocator", "placeholder", "options", "name", "onChange"]);

      var value = this.state.value;
      var thisList = null;
      var thisPlaceholder = null;
      var thisSelected = value;

      if (placeholder) {
        thisPlaceholder = React.createElement(SemanticUI, {
          style: Styles.dropdownPlaceholder
        }, placeholder);
      }

      if (options) {
        thisList = React.createElement(Menu, null, options.map(function (l, key) {
          var optionValue = valueLocator(l);
          var optionText = labelLocator(l);
          var optionClasses = null;

          if (value === optionValue) {
            thisSelected = optionText;
            optionClasses = 'active';
          }

          return React.createElement(Item, {
            onClick: _this2.handleSelect(l),
            "data-v": optionValue,
            key: key,
            className: optionClasses
          }, optionText);
        }));
      }

      var title = thisSelected || thisPlaceholder;
      return React.createElement(Dropdown, _extends({}, props, {
        list: thisList
      }), React.createElement("input", {
        type: "hidden",
        name: name,
        value: value || ''
      }), title);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var value = nextProps.value,
          defaultValue = nextProps.defaultValue;
      var prevValue = prevState.prevValue;
      var thisValue = value || defaultValue;

      if (thisValue !== prevValue) {
        return {
          value: thisValue,
          prevValue: thisValue
        };
      }

      return null;
    }
  }]);

  return Select;
}(PureComponent);

_defineProperty(Select, "defaultProps", {
  labelLocator: function labelLocator(d) {
    return d.label;
  },
  valueLocator: function valueLocator(d) {
    return d.value;
  },
  simple: false
});

var SelectField = function SelectField(props) {
  return React.createElement(Field, _extends({}, props, {
    inputComponent: React.createElement(Select, {
      titleStyle: Styles.dropdownTitle,
      style: Styles.dropdown,
      iconStyle: Styles.dropdownIcon
    })
  }));
};

export default Select;
export { SelectField };
var Styles = {
  dropdown: {
    border: '1px solid rgba(34,36,38,.15)',
    minHeight: 40
  },
  dropdownTitle: {
    paddingLeft: 10
  },
  dropdownPlaceholder: {
    color: '#ccc'
  },
  dropdownIcon: {
    fill: '#ccc'
  }
};