import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { PureComponent, cloneElement, createElement, isValidElement } from 'react';
import { build, mixClass, reactStyle, Icon, Rail, SemanticUI } from 'react-atomic-molecule';
import Hamburger from 'ricon/HamburgerToArrow';
import { connect } from 'reshow-flux';
import get, { toJS } from 'get-object-value';
import { hasClass, removeClass } from 'class-lib';
import { queryOne } from 'css-query-selector';
import getOffset from 'getoffset';
import callfunc from 'call-func';
var keys = Object.keys;
import { navigationStore, navigationDispatch } from '../../src/index';

var getMenuByArray = function getMenuByArray(onClick) {
  return function (arr, component, active, menuOrder) {
    if (!arr) {
      return null;
    }

    var results = [];
    var buildComp = build(component);

    if (!menuOrder) {
      menuOrder = keys(arr);
    }

    menuOrder.forEach(function (key) {
      var _arr$key = arr[key],
          href = _arr$key.href,
          text = _arr$key.text,
          className = _arr$key.className,
          others = _objectWithoutProperties(_arr$key, ["href", "text", "className"]);

      var classes = mixClass(className, 'item', {
        active: active === key
      });
      results.push(buildComp(_objectSpread({}, others, {
        key: key,
        href: href,
        name: key,
        className: classes,
        onClick: onClick
      }), text));
    });
    return results;
  };
};

var DefaultIcon = function DefaultIcon(_ref) {
  var className = _ref.className,
      on = _ref.on,
      right = _ref.right,
      onClick = _ref.onClick,
      iconStyle = _ref.iconStyle,
      hamburgerStyle = _ref.hamburgerStyle;
  return React.createElement(Icon, {
    onClick: onClick,
    className: mixClass(className, 'hamburger-icon'),
    styles: reactStyle(_objectSpread({}, Styles.icon, {}, iconStyle), false, false)
  }, React.createElement(Hamburger, {
    on: on,
    right: right,
    styles: reactStyle(_objectSpread({}, Styles.hamburger, {}, hamburgerStyle), false, false)
  }));
};

var _ref2 =
/*#__PURE__*/
React.createElement(DefaultIcon, null);

var _ref3 =
/*#__PURE__*/
React.createElement(DefaultIcon, null);

var SideMenu =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(SideMenu, _PureComponent);

  function SideMenu() {
    _classCallCheck(this, SideMenu);

    return _possibleConstructorReturn(this, _getPrototypeOf(SideMenu).apply(this, arguments));
  }

  _createClass(SideMenu, [{
    key: "getRoot",
    value: function getRoot() {
      var root = this.props.root;
      var thisRoot = root;

      if (!thisRoot) {
        thisRoot = document.body;
      }

      return thisRoot;
    }
  }, {
    key: "updateRoot",
    value: function updateRoot(on) {
      var _this$props = this.props,
          rootActiveClass = _this$props.rootActiveClass,
          rootInactiveClass = _this$props.rootInactiveClass;
      var thisRoot = this.getRoot();

      if (!thisRoot) {
        console.wanr('root not found');
        return;
      }

      if (on) {
        thisRoot.className = mixClass(thisRoot.className, rootActiveClass);
        thisRoot.className = removeClass(thisRoot.className, rootInactiveClass);
      } else {
        thisRoot.className = mixClass(thisRoot.className, rootInactiveClass);
        thisRoot.className = removeClass(thisRoot.className, rootActiveClass);
      }
    }
  }, {
    key: "handleSwitch",
    value: function handleSwitch(stateOn, e) {
      var _this$props2 = this.props,
          id = _this$props2.id,
          onSwitch = _this$props2.onSwitch;
      var isValidStateOn = 'boolean' === typeof stateOn;
      var on = !(isValidStateOn ? stateOn : this.state.on);
      var defaultOff = getOffset(queryOne('.sidebar .default-off'));
      var isSet = isValidStateOn || defaultOff.w && defaultOff.h;

      if (isSet) {
        navigationDispatch({
          id: id,
          params: {
            on: on
          }
        });
      }

      callfunc(onSwitch, [e, on, isSet]);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var on = this.state.on;

      if ('undefined' !== typeof on) {
        this.updateRoot(on);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var on = this.state.on;

      if (on !== prevState.on) {
        this.updateRoot(on);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$props3 = this.props,
          rootActiveClass = _this$props3.rootActiveClass,
          rootInactiveClass = _this$props3.rootInactiveClass;
      var thisRoot = this.getRoot();
      thisRoot.className = removeClass(thisRoot.className, rootActiveClass);
      thisRoot.className = removeClass(thisRoot.className, rootInactiveClass);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          onSwitch = _this$props4.onSwitch,
          fixedMini = _this$props4.fixedMini,
          defaultOnIcon = _this$props4.defaultOnIcon,
          defaultOffIcon = _this$props4.defaultOffIcon,
          iconStyle = _this$props4.iconStyle,
          hamburgerStyle = _this$props4.hamburgerStyle,
          component = _this$props4.component,
          linkComponent = _this$props4.linkComponent,
          className = _this$props4.className,
          menus = _this$props4.menus,
          menuOrder = _this$props4.menuOrder,
          root = _this$props4.root,
          rootActiveClass = _this$props4.rootActiveClass,
          rootInactiveClass = _this$props4.rootInactiveClass,
          others = _objectWithoutProperties(_this$props4, ["onSwitch", "fixedMini", "defaultOnIcon", "defaultOffIcon", "iconStyle", "hamburgerStyle", "component", "linkComponent", "className", "menus", "menuOrder", "root", "rootActiveClass", "rootInactiveClass"]);

      var _this$state = this.state,
          activeMenu = _this$state.activeMenu,
          on = _this$state.on;
      var isInit = !on && false !== on;
      var menuItems = getMenuByArray(this.handleSwitch.bind(this, null))(toJS(menus), linkComponent, activeMenu, toJS(menuOrder));
      var menuElement = build(component)(others, menuItems);
      var thisDefaultOnIcon = null;
      var thisDefaultOffIcon = defaultOffIcon;
      var defaultOff = isInit ? false : on;

      if (!thisDefaultOffIcon) {
        thisDefaultOffIcon = _ref2;
      }

      thisDefaultOffIcon = cloneElement(thisDefaultOffIcon, {
        on: defaultOff,
        onClick: this.handleSwitch.bind(this, defaultOff),
        className: 'default-off',
        iconStyle: iconStyle,
        hamburgerStyle: hamburgerStyle
      });

      if (!fixedMini) {
        var defaultOn = isInit ? true : on;
        thisDefaultOnIcon = defaultOnIcon;

        if (!thisDefaultOnIcon) {
          thisDefaultOnIcon = _ref3;
        }

        thisDefaultOnIcon = cloneElement(thisDefaultOnIcon, {
          on: true,
          right: !defaultOn,
          onClick: this.handleSwitch.bind(this, defaultOn),
          className: 'default-on',
          iconStyle: iconStyle,
          hamburgerStyle: hamburgerStyle
        });
      }

      var classes = mixClass({
        active: on,
        inactive: on === false
      }, 'sidebar', className);
      return React.createElement(Rail, {
        className: classes
      }, menuElement, thisDefaultOnIcon, thisDefaultOffIcon);
    }
  }], [{
    key: "getStores",
    value: function getStores() {
      return [navigationStore];
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var on = nextProps.on;

      if (on !== prevState.prePropsOn) {
        return {
          on: on,
          prePropsOn: on
        };
      } else {
        return null;
      }
    }
  }, {
    key: "calculateState",
    value: function calculateState(prevState, props) {
      var id = get(props, ['id'], 'default');
      var state = navigationStore.getState();
      var settings = state.get(id);
      var storeOn = get(settings, ['on']);
      var on;

      if ('undefined' === typeof storeOn) {
        on = prevState.on;
      } else {
        on = storeOn;
      }

      return {
        on: on,
        activeMenu: get(settings, ['activeMenu'])
      };
    }
  }]);

  return SideMenu;
}(PureComponent);

_defineProperty(SideMenu, "defaultProps", {
  component: SemanticUI,
  linkComponent: 'a',
  menus: [],
  root: null,
  rootActiveClass: 'side-menu-active',
  rootInactiveClass: 'side-menu-inactive'
});

export default connect(SideMenu, {
  withProps: true
});
var Styles = {
  icon: {
    background: '#000',
    padding: 5,
    width: 24,
    height: 24,
    position: 'fixed',
    top: 0,
    left: 0,
    zIndex: 1,
    cursor: 'pointer',
    opacity: '.5',
    transition: ['all 0.2s ease-out']
  },
  hamburger: {
    fill: '#fff'
  }
};