import _objectWithoutProperties from "reshow-runtime/es/helpers/objectWithoutProperties";
import _classCallCheck from "reshow-runtime/es/helpers/classCallCheck";
import _createClass from "reshow-runtime/es/helpers/createClass";
import _possibleConstructorReturn from "reshow-runtime/es/helpers/possibleConstructorReturn";
import _getPrototypeOf from "reshow-runtime/es/helpers/getPrototypeOf";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inherits from "reshow-runtime/es/helpers/inherits";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { PureComponent, Children } from 'react';
import { mixClass, build, SemanticUI } from 'react-atomic-molecule';

var TabView =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(TabView, _PureComponent);

  function TabView() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, TabView);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(TabView)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {});

    return _this;
  }

  _createClass(TabView, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          id = _this$props.id,
          style = _this$props.style,
          contentStyle = _this$props.contentStyle,
          menuStyle = _this$props.menuStyle,
          menu = _this$props.menu,
          body = _this$props.body,
          disableSwitch = _this$props.disableSwitch,
          stackable = _this$props.stackable,
          rightMenu = _this$props.rightMenu,
          bottom = _this$props.bottom,
          left = _this$props.left,
          right = _this$props.right,
          props = _objectWithoutProperties(_this$props, ["id", "style", "contentStyle", "menuStyle", "menu", "body", "disableSwitch", "stackable", "rightMenu", "bottom", "left", "right"]);

      var tabMenuItems = [];
      var stateSelected = this.state.selected;
      var contentView = null;
      var content = null;
      var tabMenu;
      Children.map(props.children, function (item, itemKey) {
        var itemProps = item.props; // detect selected

        var nodeKey = itemProps.name || itemKey;

        if (true === stateSelected) {
          stateSelected = nodeKey;
        }

        var selected = nodeKey === stateSelected;
        Children.map(itemProps.children, function (node, index) {
          if (index % 2 || 1 === Children.count(itemProps.children)) {
            var nodeProps = node.props;
            var nodeClasses = mixClass(nodeProps.className, 'item', {
              active: selected
            });
            node = build(node)({
              key: nodeKey,
              selected: selected,
              className: nodeClasses,
              style: _objectSpread({}, Styles.tabItem, {}, nodeProps.style),
              onClickCapture: function onClickCapture(e) {
                if (!disableSwitch) {
                  if (!nodeProps.disableSwitch) {
                    _this2.setState({
                      selected: nodeKey
                    });
                  }
                }

                if (props.onTabItemPress) {
                  props.onTabItemPress(nodeKey);
                }
              }
            });
            tabMenuItems.push(node);
          } else {
            if (selected) {
              contentView = node;
            }
          }
        });
      }); // Tab Menu

      if (rightMenu) {
        tabMenuItems.push(build(rightMenu)({
          key: 'r-menu'
        }));
      }

      var menuOpt = {
        top: !bottom && !left && !right,
        bottom: bottom,
        vertical: left || right,
        stackable: stackable
      };
      var menuClasses = mixClass('attached tabular menu', menuOpt);
      tabMenu = build(menu)({
        key: 'menu',
        style: menuStyle,
        className: menuClasses
      }, tabMenuItems);

      if (contentView) {
        // Tab Body
        var contentClasses = mixClass('attached tab segment active', {
          top: !menuOpt.top,
          bottom: menuOpt.top
        });
        content = build(body)({
          key: 'content',
          style: _objectSpread({}, Styles.tabBody, {}, contentStyle),
          className: contentClasses
        }, contentView);
      }

      var childOrder = menuOpt.top ? [tabMenu, content] : [content, tabMenu];
      return React.createElement(SemanticUI, {
        style: style,
        id: id
      }, childOrder);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(_ref, _ref2) {
      var selected = _ref.selected;
      var lastPropsSelected = _ref2.lastPropsSelected;

      if (lastPropsSelected !== selected) {
        return {
          lastPropsSelected: selected,
          selected: selected
        };
      } else {
        return null;
      }
    }
  }]);

  return TabView;
}(PureComponent);

_defineProperty(TabView, "defaultProps", {
  disableSwitch: false,
  stackable: true,
  selected: true,
  body: SemanticUI,
  menu: SemanticUI
});

export default TabView;
var Styles = {
  tabBody: {
    boxSizing: 'border-box'
  },
  tabItem: {
    boxSizing: 'border-box',
    cursor: 'pointer'
  }
};